package java.io;

import java.lang.invoke.MethodType;
import java.security.PrivilegedExceptionAction;
import java.lang.invoke.MethodHandles;
import java.security.PrivilegedActionException;
import java.security.AccessController;
import java.lang.reflect.RecordComponent;
import java.util.Objects;
import java.lang.invoke.MethodHandle;
import java.util.Arrays;
import jdk.internal.util.ByteArray;
import java.util.Set;
import java.util.HashSet;
import java.util.ArrayList;
import jdk.internal.misc.Unsafe;
import java.lang.reflect.Field;
import java.lang.reflect.Member;
import java.util.concurrent.ConcurrentHashMap;
import java.util.Map;
import java.lang.ref.WeakReference;
import java.util.concurrent.ConcurrentMap;
import java.lang.ref.ReferenceQueue;
import java.lang.reflect.InvocationTargetException;
import sun.reflect.CallerSensitive;
import java.lang.reflect.Method;
import java.security.ProtectionDomain;
import java.lang.reflect.Constructor;
import sun.reflect.ReflectionFactory;

public class ObjectStreamClass implements Serializable
{
    public static final ObjectStreamField[] NO_FIELDS;
    private static final long serialVersionUID = -6120832682080437368L;
    private static final ObjectStreamField[] serialPersistentFields;
    private static boolean disableSerialConstructorChecks;
    private static final ReflectionFactory reflFactory;
    private Class<?> cl;
    private String name;
    private volatile Long suid;
    private boolean isProxy;
    private boolean isEnum;
    private boolean serializable;
    private boolean externalizable;
    private boolean hasWriteObjectData;
    private boolean hasBlockExternalData;
    private ClassNotFoundException resolveEx;
    private ExceptionInfo deserializeEx;
    private ExceptionInfo serializeEx;
    private ExceptionInfo defaultSerializeEx;
    private ObjectStreamField[] fields;
    private int primDataSize;
    private int numObjFields;
    private FieldReflector fieldRefl;
    private volatile ClassDataSlot[] dataLayout;
    private Constructor<?> cons;
    private ProtectionDomain[] domains;
    private Method writeObjectMethod;
    private Method readObjectMethod;
    private Method readObjectNoDataMethod;
    private Method writeReplaceMethod;
    private Method readResolveMethod;
    private ObjectStreamClass localDesc;
    private ObjectStreamClass superDesc;
    private boolean initialized;
    
    private static void initNative() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public static ObjectStreamClass lookup(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public static ObjectStreamClass lookupAny(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public String getName() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public long getSerialVersionUID() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    @CallerSensitive
    public Class<?> forClass() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public ObjectStreamField[] getFields() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    public ObjectStreamField getField(String s) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    @Override
    public String toString() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    static ObjectStreamClass lookup(Class<?> clazz, boolean b) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private ObjectStreamClass(Class<?> clazz) {
        throw new Error("Unresolved compilation problems: \n\tThe left-hand side of an assignment must be a variable\n\t$assertionsDisabled cannot be resolved to a variable\n");
    }
    
    ObjectStreamClass() {
        throw new Error("Unresolved compilation problems: \n\tThe left-hand side of an assignment must be a variable\n\t$assertionsDisabled cannot be resolved to a variable\n");
    }
    
    private ProtectionDomain noPermissionsDomain() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private ProtectionDomain[] getProtectionDomains(Constructor<?> constructor, Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void initProxy(Class<?> clazz, ClassNotFoundException ex, ObjectStreamClass objectStreamClass) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void initNonProxy(ObjectStreamClass objectStreamClass, Class<?> clazz, ClassNotFoundException ex, ObjectStreamClass objectStreamClass2) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void readNonProxy(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void writeNonProxy(ObjectOutputStream objectOutputStream) throws IOException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ClassNotFoundException getResolveException() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private final void requireInitialized() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    final void checkInitialized() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void checkDeserialize() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void checkSerialize() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void checkDefaultSerialize() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ObjectStreamClass getSuperDesc() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ObjectStreamClass getLocalDesc() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ObjectStreamField[] getFields(boolean b) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ObjectStreamField getField(String s, Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean isProxy() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean isEnum() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean isExternalizable() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean isSerializable() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasBlockExternalData() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasWriteObjectData() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean isInstantiable() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasWriteObjectMethod() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasReadObjectMethod() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasReadObjectNoDataMethod() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasWriteReplaceMethod() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    boolean hasReadResolveMethod() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    Object newInstance() throws InstantiationException, InvocationTargetException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void invokeWriteObject(Object o, ObjectOutputStream objectOutputStream) throws IOException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void invokeReadObject(Object o, ObjectInputStream objectInputStream) throws ClassNotFoundException, IOException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void invokeReadObjectNoData(Object o) throws IOException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    Object invokeWriteReplace(Object o) throws IOException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    Object invokeReadResolve(Object o) throws IOException, UnsupportedOperationException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    ClassDataSlot[] getClassDataLayout() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private ClassDataSlot[] getClassDataLayout0() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n\tThe left-hand side of an assignment must be a variable\n");
    }
    
    int getPrimDataSize() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    int getNumObjFields() {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void getPrimFieldValues(Object o, byte[] array) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void setPrimFieldValues(Object o, byte[] array) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void getObjFieldValues(Object o, Object[] array) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    void setObjFieldValues(Object o, Object[] array) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private void computeFieldOffsets() throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private ObjectStreamClass getVariantFor(Class<?> clazz) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static Constructor<?> getExternalizableConstructor(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static boolean superHasAccessibleConstructor(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static Constructor<?> getSerializableConstructor(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static Method getInheritableMethod(Class<?> clazz, String s, Class<?>[] array, Class<?> clazz2) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static Method getPrivateMethod(Class<?> clazz, String s, Class<?>[] array, Class<?> clazz2) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static boolean packageEquals(Class<?> clazz, Class<?> clazz2) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static String getPackageName(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static boolean classNamesEqual(String s, String s2) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static String getClassSignature(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static String getMethodSignature(Class<?>[] array, Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static void throwMiscException(Throwable t) throws IOException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static ObjectStreamField[] getSerialFields(Class<?> clazz) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static ObjectStreamField[] getDeclaredSerialFields(Class<?> clazz) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static ObjectStreamField[] getDefaultSerialFields(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static Long getDeclaredSUID(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static long computeDefaultSUID(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static boolean hasStaticInitializer(Class<?> clazz) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static FieldReflector getReflector(ObjectStreamField[] array, ObjectStreamClass objectStreamClass) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static ObjectStreamField[] matchFields(ObjectStreamField[] array, ObjectStreamClass objectStreamClass) throws InvalidClassException {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    static void processQueue(ReferenceQueue<Class<?>> referenceQueue, ConcurrentMap<? extends WeakReference<Class<?>>, ?> concurrentMap) {
        throw new Error("Unresolved compilation problem: \n");
    }
    
    private static class Caches
    {
        static final ClassCache<ObjectStreamClass> localDescs;
        static final ClassCache<Map<FieldReflectorKey, FieldReflector>> reflectors;
        
        static {
            localDescs = new ClassCache<ObjectStreamClass>() {
                @Override
                protected ObjectStreamClass computeValue(Class<?> type) {
                    return new ObjectStreamClass(type);
                }
            };
            reflectors = new ClassCache<Map<FieldReflectorKey, FieldReflector>>() {
                @Override
                protected Map<FieldReflectorKey, FieldReflector> computeValue(Class<?> type) {
                    return new ConcurrentHashMap<>();
                }
            };
        }
    }
    
    private static class ExceptionInfo
    {
        private final String className;
        private final String message;
        
        ExceptionInfo(String cn, String msg) {
            this.className = cn;
            this.message = msg;
        }
        
        InvalidClassException newInvalidClassException() {
            return new InvalidClassException(this.className, this.message);
        }
    }
    
    static class ClassDataSlot
    {
        final ObjectStreamClass desc;
        final boolean hasData;
        
        ClassDataSlot(ObjectStreamClass desc, boolean hasData) {
            this.desc = desc;
            this.hasData = hasData;
        }
    }
    
    private static final class MemberSignature
    {
        public final Member member;
        public final String name;
        public final String signature;
        
        public MemberSignature(Field field) {
            this.member = field;
            this.name = field.getName();
            this.signature = field.getType().descriptorString();
        }
        
        public MemberSignature(Constructor<?> cons) {
            this.member = cons;
            this.name = cons.getName();
            this.signature = ObjectStreamClass.getMethodSignature(cons.getParameterTypes(), Void.TYPE);
        }
        
        public MemberSignature(Method meth) {
            this.member = meth;
            this.name = meth.getName();
            this.signature = ObjectStreamClass.getMethodSignature(meth.getParameterTypes(), meth.getReturnType());
        }
    }
    
    private static final class FieldReflector
    {
        private static final Unsafe UNSAFE;
        private final ObjectStreamField[] fields;
        private final int numPrimFields;
        private final long[] readKeys;
        private final long[] writeKeys;
        private final int[] offsets;
        private final char[] typeCodes;
        private final Class<?>[] types;
        
        FieldReflector(ObjectStreamField[] fields) {
            this.fields = fields;
            int nfields = fields.length;
            this.readKeys = new long[nfields];
            this.writeKeys = new long[nfields];
            this.offsets = new int[nfields];
            this.typeCodes = new char[nfields];
            ArrayList<Class<?>> typeList = new ArrayList<>();
            Set<Long> usedKeys = new HashSet<>();
            for (int i = 0; i < nfields; ++i) {
                ObjectStreamField f = fields[i];
                Field rf = f.getField();
                long key = (rf != null) ? FieldReflector.UNSAFE.objectFieldOffset(rf) : -1L;
                this.readKeys[i] = key;
                this.writeKeys[i] = (usedKeys.add(Long.valueOf(key)) ? key : -1L);
                this.offsets[i] = f.getOffset();
                this.typeCodes[i] = f.getTypeCode();
                if (!f.isPrimitive()) {
                    typeList.add((rf != null) ? rf.getType() : null);
                }
            }
            this.types = (Class[])typeList.toArray(new Class[typeList.size()]);
            this.numPrimFields = nfields - this.types.length;
        }
        
        ObjectStreamField[] getFields() {
            return this.fields;
        }
        
        void getPrimFieldValues(Object obj, byte[] buf) {
            if (obj == null) {
                throw new NullPointerException();
            }
            for (int i = 0; i < this.numPrimFields; ++i) {
                long key = this.readKeys[i];
                int off = this.offsets[i];
                switch (this.typeCodes[i]) {
                    case 'Z': {
                        ByteArray.setBoolean(buf, off, FieldReflector.UNSAFE.getBoolean(obj, key));
                        break;
                    }
                    case 'B': {
                        buf[off] = FieldReflector.UNSAFE.getByte(obj, key);
                        break;
                    }
                    case 'C': {
                        ByteArray.setChar(buf, off, FieldReflector.UNSAFE.getChar(obj, key));
                        break;
                    }
                    case 'S': {
                        ByteArray.setShort(buf, off, FieldReflector.UNSAFE.getShort(obj, key));
                        break;
                    }
                    case 'I': {
                        ByteArray.setInt(buf, off, FieldReflector.UNSAFE.getInt(obj, key));
                        break;
                    }
                    case 'F': {
                        ByteArray.setFloat(buf, off, FieldReflector.UNSAFE.getFloat(obj, key));
                        break;
                    }
                    case 'J': {
                        ByteArray.setLong(buf, off, FieldReflector.UNSAFE.getLong(obj, key));
                        break;
                    }
                    case 'D': {
                        ByteArray.setDouble(buf, off, FieldReflector.UNSAFE.getDouble(obj, key));
                        break;
                    }
                    default: {
                        throw new InternalError();
                    }
                }
            }
        }
        
        void setPrimFieldValues(Object obj, byte[] buf) {
            if (obj == null) {
                throw new NullPointerException();
            }
            for (int i = 0; i < this.numPrimFields; ++i) {
                long key = this.writeKeys[i];
                if (key != -1L) {
                    int off = this.offsets[i];
                    switch (this.typeCodes[i]) {
                        case 'Z': {
                            FieldReflector.UNSAFE.putBoolean(obj, key, ByteArray.getBoolean(buf, off));
                            break;
                        }
                        case 'B': {
                            FieldReflector.UNSAFE.putByte(obj, key, buf[off]);
                            break;
                        }
                        case 'C': {
                            FieldReflector.UNSAFE.putChar(obj, key, ByteArray.getChar(buf, off));
                            break;
                        }
                        case 'S': {
                            FieldReflector.UNSAFE.putShort(obj, key, ByteArray.getShort(buf, off));
                            break;
                        }
                        case 'I': {
                            FieldReflector.UNSAFE.putInt(obj, key, ByteArray.getInt(buf, off));
                            break;
                        }
                        case 'F': {
                            FieldReflector.UNSAFE.putFloat(obj, key, ByteArray.getFloat(buf, off));
                            break;
                        }
                        case 'J': {
                            FieldReflector.UNSAFE.putLong(obj, key, ByteArray.getLong(buf, off));
                            break;
                        }
                        case 'D': {
                            FieldReflector.UNSAFE.putDouble(obj, key, ByteArray.getDouble(buf, off));
                            break;
                        }
                        default: {
                            throw new InternalError();
                        }
                    }
                }
            }
        }
        
        void getObjFieldValues(Object obj, Object[] vals) {
            if (obj == null) {
                throw new NullPointerException();
            }
            int i = this.numPrimFields;
            while (i < this.fields.length) {
                int n = this.offsets[i];
                switch (this.typeCodes[i]) {
                    case 'L':
                    case '[': {
                        vals[n] = FieldReflector.UNSAFE.getReference(obj, this.readKeys[i]);
                        ++i;
                        continue;
                    }
                    default: {
                        throw new InternalError();
                    }
                }
            }
        }
        
        void checkObjectFieldValueTypes(Object obj, Object[] vals) {
            this.setObjFieldValues(obj, vals, true);
        }
        
        void setObjFieldValues(Object obj, Object[] vals) {
            this.setObjFieldValues(obj, vals, false);
        }
        
        private void setObjFieldValues(Object obj, Object[] vals, boolean dryRun) {
            if (obj == null) {
                throw new NullPointerException();
            }
            for (int i = this.numPrimFields; i < this.fields.length; ++i) {
                long key = this.writeKeys[i];
                if (key != -1L) {
                    switch (this.typeCodes[i]) {
                        case 'L':
                        case '[': {
                            Object val = vals[this.offsets[i]];
                            if (val != null && !this.types[i - this.numPrimFields].isInstance(val)) {
                                Field f = this.fields[i].getField();
                                throw new ClassCastException("cannot assign instance of " + val.getClass().getName() + " to field " + f.getDeclaringClass().getName() + "." + f.getName() + " of type " + f.getType().getName() + " in instance of " + obj.getClass().getName());
                            }
                            if (!dryRun) {
                                FieldReflector.UNSAFE.putReference(obj, key, val);
                            }
                            break;
                        }
                        default: {
                            throw new InternalError();
                        }
                    }
                }
            }
        }
        
        static {
            UNSAFE = Unsafe.getUnsafe();
        }
    }
    
    private static class FieldReflectorKey
    {
        private final String[] sigs;
        private final int hash;
        
        FieldReflectorKey(ObjectStreamField[] fields) {
            this.sigs = new String[2 * fields.length];
            int i = 0;
            int j = 0;
            while (i < fields.length) {
                ObjectStreamField f = fields[i];
                this.sigs[j++] = f.getName();
                this.sigs[j++] = f.getSignature();
                ++i;
            }
            this.hash = Arrays.hashCode(this.sigs);
        }
        
        @Override
        public int hashCode() {
            return this.hash;
        }
        
        @Override
        public boolean equals(Object obj) {
            if (obj != this) {
                if (obj instanceof FieldReflectorKey) {
                    FieldReflectorKey other = (FieldReflectorKey)obj;
                    if (Arrays.equals(this.sigs, other.sigs)) {
                        return true;
                    }
                }
                return false;
            }
            return true;
        }
    }
    
    private static final class DeserializationConstructorsCache extends ConcurrentHashMap<Key, MethodHandle>
    {
        private static final int MAX_SIZE = 10;
        private Key.Impl first;
        private Key.Impl last;
        
        DeserializationConstructorsCache() {
            super(2);
        }
        
        MethodHandle get(ObjectStreamField[] fields) {
            return (MethodHandle)this.get(new Key.Lookup(fields));
        }
        
        synchronized MethodHandle putIfAbsentAndGet(ObjectStreamField[] fields, MethodHandle mh) {
            Key.Impl key = new Key.Impl(fields);
            MethodHandle oldMh = (MethodHandle)this.putIfAbsent(key, mh);
            if (oldMh != null) {
                return oldMh;
            }
            if (this.last == null) {
                this.first = key;
                this.last = key;
            }
            else {
                this.last.next = key;
                this.last = key;
            }
            if (this.size() > 10) {
                assert this.first != null;
                this.remove(this.first);
                this.first = this.first.next;
                if (this.first == null) {
                    this.last = null;
                }
            }
            return mh;
        }
        
        abstract static class Key
        {
            abstract int length();
            
            abstract String fieldName(int p0);
            
            abstract Class<?> fieldType(int p0);
            
            @Override
            public final int hashCode() {
                int n = this.length();
                int h = 0;
                for (int i = 0; i < n; ++i) {
                    h = h * 31 + this.fieldType(i).hashCode();
                }
                for (int i = 0; i < n; ++i) {
                    h = h * 31 + this.fieldName(i).hashCode();
                }
                return h;
            }
            
            @Override
            public final boolean equals(Object obj) {
                if (obj instanceof Key) {
                    Key other = (Key)obj;
                    int n = this.length();
                    if (n != other.length()) {
                        return false;
                    }
                    for (int i = 0; i < n; ++i) {
                        if (this.fieldType(i) != other.fieldType(i)) {
                            return false;
                        }
                    }
                    for (int i = 0; i < n; ++i) {
                        if (!this.fieldName(i).equals(other.fieldName(i))) {
                            return false;
                        }
                    }
                    return true;
                }
                else {
                    return false;
                }
            }
            
            static final class Lookup extends Key
            {
                final ObjectStreamField[] fields;
                
                Lookup(ObjectStreamField[] fields) {
                    this.fields = fields;
                }
                
                @Override
                int length() {
                    return this.fields.length;
                }
                
                @Override
                String fieldName(int i) {
                    return this.fields[i].getName();
                }
                
                @Override
                Class<?> fieldType(int i) {
                    return this.fields[i].getType();
                }
            }
            
            static final class Impl extends Key
            {
                Impl next;
                final String[] fieldNames;
                final Class<?>[] fieldTypes;
                
                Impl(ObjectStreamField[] fields) {
                    this.fieldNames = new String[fields.length];
                    this.fieldTypes = new Class[fields.length];
                    for (int i = 0; i < fields.length; ++i) {
                        this.fieldNames[i] = fields[i].getName();
                        this.fieldTypes[i] = fields[i].getType();
                    }
                }
                
                @Override
                int length() {
                    return this.fieldNames.length;
                }
                
                @Override
                String fieldName(int i) {
                    return this.fieldNames[i];
                }
                
                @Override
                Class<?> fieldType(int i) {
                    return this.fieldTypes[i];
                }
            }
        }
    }
    
    static final class RecordSupport
    {
        private static final Map<Class<?>, MethodHandle> PRIM_VALUE_EXTRACTORS;
        
        static MethodHandle deserializationCtr(ObjectStreamClass desc) {
            MethodHandle mh = desc.deserializationCtr;
            if (mh != null) {
                return mh;
            }
            mh = desc.deserializationCtrs.get(desc.getFields(false));
            if (mh != null) {
                return desc.deserializationCtr = mh;
            }
            RecordComponent[] recordComponents;
            try {
                Class<?> cls = desc.forClass();
                Objects.requireNonNull(cls);
                PrivilegedExceptionAction<RecordComponent[]> pa = (PrivilegedExceptionAction<RecordComponent[]>)cls::getRecordComponents;
                recordComponents = (RecordComponent[])AccessController.doPrivileged(pa);
            }
            catch (PrivilegedActionException e) {
                throw new InternalError(e.getCause());
            }
            mh = desc.getRecordConstructor();
            mh = mh.asType(mh.type().changeReturnType(Object.class));
            mh = MethodHandles.dropArguments(mh, mh.type().parameterCount(), new Class[] { byte[].class, Object[].class });
            for (int i = recordComponents.length - 1; i >= 0; --i) {
                String name = recordComponents[i].getName();
                Class<?> type = recordComponents[i].getType();
                MethodHandle combiner = streamFieldExtractor(name, type, desc);
                mh = MethodHandles.foldArguments(mh, i, combiner);
            }
            return desc.deserializationCtr = desc.deserializationCtrs.putIfAbsentAndGet(desc.getFields(false), mh);
        }
        
        private static int numberPrimValues(ObjectStreamClass desc) {
            ObjectStreamField[] fields = desc.getFields();
            int primValueCount = 0;
            for (int i = 0; i < fields.length && fields[i].isPrimitive(); ++i) {
                ++primValueCount;
            }
            return primValueCount;
        }
        
        private static MethodHandle streamFieldExtractor(String pName, Class<?> pType, ObjectStreamClass desc) {
            ObjectStreamField[] fields = desc.getFields(false);
            int i = 0;
            while (i < fields.length) {
                ObjectStreamField f = fields[i];
                String fName = f.getName();
                if (!fName.equals(pName)) {
                    ++i;
                }
                else {
                    Class<?> fType = f.getField().getType();
                    if (!pType.isAssignableFrom(fType)) {
                        throw new InternalError(fName + " unassignable, pType:" + pType + ", fType:" + fType);
                    }
                    if (f.isPrimitive()) {
                        MethodHandle mh = (MethodHandle)RecordSupport.PRIM_VALUE_EXTRACTORS.get(fType);
                        if (mh == null) {
                            throw new InternalError("Unexpected type: " + fType);
                        }
                        mh = MethodHandles.insertArguments(mh, 1, new Object[] { Integer.valueOf(f.getOffset()) });
                        mh = MethodHandles.dropArguments(mh, 1, new Class[] { Object[].class });
                        if (pType != fType) {
                            mh = mh.asType(mh.type().changeReturnType(pType));
                        }
                        return mh;
                    }
                    else {
                        MethodHandle mh = MethodHandles.arrayElementGetter(Object[].class);
                        mh = MethodHandles.insertArguments(mh, 1, new Object[] { Integer.valueOf(i - numberPrimValues(desc)) });
                        mh = MethodHandles.dropArguments(mh, 0, new Class[] { byte[].class });
                        if (pType != Object.class) {
                            mh = mh.asType(mh.type().changeReturnType(pType));
                        }
                        return mh;
                    }
                }
            }
            return MethodHandles.empty(MethodType.methodType(pType, byte[].class, new Class[] { Object[].class }));
        }
        
        static {
            MethodHandles.Lookup lkp = MethodHandles.lookup();
            try {
                PRIM_VALUE_EXTRACTORS = Map.of(Byte.TYPE, MethodHandles.arrayElementGetter(byte[].class), Short.TYPE, lkp.findStatic(ByteArray.class, "getShort", MethodType.methodType(Short.TYPE, byte[].class, new Class[] { Integer.TYPE })), Integer.TYPE, lkp.findStatic(ByteArray.class, "getInt", MethodType.methodType(Integer.TYPE, byte[].class, new Class[] { Integer.TYPE })), Long.TYPE, lkp.findStatic(ByteArray.class, "getLong", MethodType.methodType(Long.TYPE, byte[].class, new Class[] { Integer.TYPE })), Float.TYPE, lkp.findStatic(ByteArray.class, "getFloat", MethodType.methodType(Float.TYPE, byte[].class, new Class[] { Integer.TYPE })), Double.TYPE, lkp.findStatic(ByteArray.class, "getDouble", MethodType.methodType(Double.TYPE, byte[].class, new Class[] { Integer.TYPE })), Character.TYPE, lkp.findStatic(ByteArray.class, "getChar", MethodType.methodType(Character.TYPE, byte[].class, new Class[] { Integer.TYPE })), Boolean.TYPE, lkp.findStatic(ByteArray.class, "getBoolean", MethodType.methodType(Boolean.TYPE, byte[].class, new Class[] { Integer.TYPE })));
            }
            catch (NoSuchMethodException | IllegalAccessException e) {
                throw new InternalError("Can't lookup " + ByteArray.class.getName() + ".getXXX", e);
            }
        }
    }
}
